#ifndef macros_h
#define macros_h

/* This defines the macro structures.
 *
 * $Log: macros.h,v $
 * Revision 1.2  1997/06/04 04:28:56  david
 * ANSI-fied program.
 *
 */

#ifdef DECLARE_IDS
static char *MacroID = "$Id: macros.h,v 1.2 1997/06/04 04:28:56 david Exp $";
#endif /* DECLARE_IDS */

struct lines
   {
   int line; /* Line number */
   char *lptr; /* Pointer to line */
   struct lines *next;
   };
   
struct parms
   {
   char *parname;      /* A Parameter of the MACRO */
   struct parms *next; /* Pointer to next parameter */
   };
   
struct macros
   {
   int line; /* Line macro begins on */
   char *name;
   struct parms *parm; /* Pointer to beginning of Parameters */
   struct lines *maclines; /* Pointer to beginning of MACRO BODY */
   struct macros *next; /* Pointer to next macro */
   };

void macro( char *, char *, char *, char * );
void macparse( struct macros *, char * );
struct macros *newmac( char * );
void macste( int );
struct macros *findmac( char * );
void domac( char *, struct macros *, char *, char * );
void makeaparm( struct lines **, char * );

#endif /* macros_h */
